package jalview.rest;

import java.net.BindException;
import java.util.HashMap;
import java.util.Map;

import jalview.bin.Cache;

public class API extends RestHandler
{
  private static final String MY_PATH = "api";

  private static final String MY_NAME = "Jalview API";

  private static Map<String, Status> statusMap = new HashMap<>();

  private static Map<String, String> requestMap = new HashMap<>();

  private static API instance = null;

  public static API getInstance() throws BindException
  {
    synchronized (API.class)
    {
      if (instance == null)
      {
        instance = new API();
      }
    }
    return instance;
  }

  private API() throws BindException
  {
    super();
  }

  private boolean init = false;

  @Override
  protected void init() throws BindException
  {
    if (init)
      return;
    super.init(MY_PATH);

    // add endpoints here
    addEndpoint(new FetchSequenceEndpoint(this));
    addEndpoint(new OpenAlignmentEndpoint(this));
    addEndpoint(new HighlightSequenceEndpoint(this));

    Cache.info("REMOVEME setting path to " + MY_PATH);
    Cache.info("REMOVEME endpoints keys:");
    for (String key : getEndpoints().keySet())
    {
      Cache.info("REMOVEME keyname=" + key);
    }
    setPath(MY_PATH);
    this.registerHandler();

    init = true;
  }

  /*
   * Shared methods below here
   */

  @Override
  public String getPath()
  {
    return MY_PATH;
  }

  protected static Map<String, Status> getStatusMap()
  {
    return statusMap;
  }

  protected static Map<String, String> getRequestMap()
  {
    return requestMap;
  }
}
